{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Обработка дисплея контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}


{$SMARTLINK ON}
{$mode objfpc}
unit rubiroScreen;
interface
uses uev3,uev3image,FPImgCanv,uev3ftfont;

{
 штатный шрифт, можно заменить на любой другой TTF
 до вызова ev3Init в программе
}
var _fontName:string='/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf';

type

  { TEv3Screen }

  TEv3Screen=class(TEv3)
    private
      fimg:TEv3Image;
      ffont:TFreeTypeFont;
      fcanvas:TFPImageCanvas;
    protected
    public
      fontName:string;
      constructor create();
      destructor destroy; override;
      // очистка изображения
      function clear:TEv3Screen;
      // вывод изображения на дисплей
      function show:TEv3Screen;
      // запись изображения на диск в png-формате
      function save(name:variant):TEv3Screen;
      // чтение изображения с диска в png-формате
      function load(name:variant):TEv3Screen;
      // рисование различных фигур карандашом и кистью
      function line(args:array of const):TEv3Screen;
      function line(x,y:variant):TEv3Screen;
      function line(x1,y1,x2,y2:variant):TEv3Screen;
      function rectangle(x1,y1,x2,y2:variant):TEv3Screen;
      function ellipse(x1,y1,x2,y2:variant):TEv3Screen;
      function circle(x,y,R:variant):TEv3Screen;
      // печать теста стандартным шрифтом
      function print(x,y:variant; arg:variant):TEv3Screen;
      function print(x,y,angle:variant; arg:variant):TEv3Screen;
      function print(x,y:variant; args:array of const):TEv3Screen;
      function print(x,y,angle:variant; args:array of const):TEv3Screen;
      // установка параметров кисти
      function brushStyle(style:variant):TEv3Screen; // число от 0
      function brushStd():TEv3Screen;
      function brushNone():TEv3Screen;
      function brushSolid():TEv3Screen;
      function brushBlack():TEv3Screen;
      function brushWhite():TEv3Screen;
      // установка параметров карандаша
      function penBig():TEv3Screen;
      function penSmall():TEv3Screen;
      function penSize(size:variant):TEv3Screen; // число от 1
      function penStyle(style:variant):TEv3Screen; // число от 0
      function penSolid():TEv3Screen;
      function penNone():TEv3Screen;
      function penStd():TEv3Screen;
      function penBlack():TEv3Screen;
      function penWhite():TEv3Screen;
      // установка параметров шрифта
      function fontBig():TEv3Screen;
      function fontSmall():TEv3Screen;
      function fontRotate(angle:variant):TEv3Screen;
      function fontSize(size:variant):TEv3Screen;
      function fontStd():TEv3Screen;
      function fontBlack():TEv3Screen;
      function fontWhite():TEv3Screen;
   public
     // доступ к объекту холста
     property Canvas:TFPImageCanvas read fcanvas;
     // доступ к объекту рисунка
     property Image:TEv3Image read fimg;
  end;

var ev3screen:TEv3Screen=nil;

implementation
uses uev3fb,uev3func,baseunix,sysutils,variants,types,fpcanvas,FPWritePNG, FPReadPNG,fpimage;

var fbuffer:pbyte=nil;
    fbf:longint;
    vinfo:fb_var_screeninfo;
    finfo:fb_fix_screeninfo;
    screensize:dword;

procedure createFB;
  begin
   fbf:=fpopen('/dev/fb0',O_RdWr);
   if (fbf < 0) then begin
          writeln(stderr,'Error: cannot open framebuffer device');
          exit;
   end;
   //   writeln('The framebuffer device was opened successfully.');
   if (fpioctl(fbf, FBIOGET_FSCREENINFO, @finfo) < 0) then begin
          writeln(stderr,'Error reading fixed information');
          exit;
   end;
   // Get variable screen information
   if (fpioctl(fbf, FBIOGET_VSCREENINFO, @vinfo) < 0) then begin
          writeln(stderr,'Error reading variable information');
          exit;
   end;
   // writeln(vinfo.xres,' ', vinfo.yres,' ', vinfo.bits_per_pixel);
   screensize := (vinfo.yres * finfo.line_length);
  // Map the device to memory
   fbuffer := fpmmap(nil, screensize, PROT_READ or PROT_WRITE, MAP_SHARED, fbf, 0);
   if (not ptruint(fbuffer) = 0) then begin
          writeln('Error: failed to map framebuffer device to memory');
          exit;
   end;
   //   writeln('The framebuffer device was mapped to memory successfully.');
 end;

procedure destroyFB;
 begin
  fpmunmap(fbuffer,screensize);
  fpclose(fbf);
 end;

procedure hideCursor;
 begin  write(#27'[?25l');flush(stdout); end;
 
procedure showCursor;
 begin  write(#27'[?25h');flush(stdout); end;

{ TEv3Screen }

constructor TEv3Screen.create();//'/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf');
begin
 inherited create;
  fontName:=_fontName;
  fimg := Tev3image.Create;
  fCanvas := TFPImageCanvas.Create (fimg);
  ffont:=TFreeTypeFont.Create;
  fontStd();
  fcanvas.font:=ffont;
  penStd();
  brushStd();
end;

destructor TEv3Screen.destroy;
begin
  fcanvas.destroy;
  fimg.destroy;
  ffont.destroy;
  inherited destroy;
end;

function TEv3Screen.clear: TEv3Screen;
begin
  result:=self;
  fimg.clear;
end;

function TEv3Screen.show: TEv3Screen;
begin
  result:=self;
  fimg.exportfb(fbuffer^);
end;

function TEv3Screen.print(x, y: variant; arg: variant): TEv3Screen;
begin
    result:=self;
    print(x,y,[arg]);
end;

function TEv3Screen.print(x, y, angle: variant; arg: variant): TEv3Screen;
begin
  result:=self;
  print(x,y,angle,[arg]);
end;

function TEv3Screen.print(x, y: variant; args: array of const): TEv3Screen;
  Var I : longint;
      s:string;
begin
    result:=self;
    if High(Args)<0 then exit;
    s:='';
    for i:=0 to High(Args) do s:=s+arg2string(args[i]);
    fcanvas.textout(x,y,s);
//    writeln(s);
end;

function TEv3Screen.print(x, y, angle: variant;
  args: array of const): TEv3Screen;
   var _angle:extended;
 begin
   result:=self;
   _angle:=ffont.angle;
   fontrotate(angle);
   print(x,y,args);
   fontrotate(_angle);
end;

function TEv3Screen.line(args: array of const): TEv3Screen;
Var I,k : longint;
    points:array of tpoint;
begin
  result:=self;
  if High(Args)<2 then exit;
  setlength(points,(high(args)+1) div 2);
  k:=0;
  for i:=0 to length(points)-1 do begin
    points[i]:=Point(arg2int(args[k]),arg2int(args[k+1]));
    inc(k,2);
//    writeln(points[i].x,' ',points[i].y);
  end;
  if length(points)=1 then 
   fcanvas.line(points[0].x,points[0].y,points[0].x,points[0].y)
  else
   fcanvas.polyline(points);
//  s:='';
//  for i:=0 to High(Args) do s:=s+arg2string(args[i]);
//  fcanvas.textout(x,y,s);
//    writeln(s);
end;

function TEv3Screen.line(x, y: variant): TEv3Screen;
begin
  result:=self;
  line([x,y]);
end;

function TEv3Screen.line(x1, y1, x2, y2: variant): TEv3Screen;
begin
  result:=self;
  line([x1,y1,x2,y2]);
end;

function TEv3Screen.rectangle(x1, y1, x2, y2: variant): TEv3Screen;
begin
  result:=self;
  fcanvas.rectangle(x1, y1, x2, y2);
end;

function TEv3Screen.save(name: variant): TEv3Screen;
 var writer : TFPCustomImageWriter;
begin
  result:=self;
  Writer := TFPWriterPNG.Create;
  with TFPWriterPNG(Writer) do
    begin
    indexed := false;
    wordsized := false;
    UseAlpha := false;
    GrayScale := false;
    end;
  fimg.inverse:=true;
  fimg.SaveToFile (name, writer);
  fimg.inverse:=false;
  writer.free;
end;

function TEv3Screen.load(name: variant): TEv3Screen;
 var reader : TFPCustomImageReader;
begin
 result:=self;
 reader := TFPReaderPNG.Create;
 fimg.inverse:=true;
 fimg.LoadFromFile (name, reader);
 fimg.inverse:=false;
 reader.free;
end;

function TEv3Screen.ellipse(x1, y1, x2, y2: variant): TEv3Screen;
begin
  result:=self;
  fcanvas.Ellipse(x1,y1,x2,y2);
end;

function TEv3Screen.circle(x, y, R: variant): TEv3Screen;
begin
  result:=self;
  fcanvas.Ellipse(x - R div 2,y-R div 2,x+r Div 2,y + R div 2);
end;

function TEv3Screen.brushStyle(style: variant): TEv3Screen;
begin
  result:=self;
  fcanvas.brush.style:= style;
end;

function TEv3Screen.brushStd: TEv3Screen;
begin
  result:=self;
  brushNone;
  brushBlack;
end;

function TEv3Screen.brushNone: TEv3Screen;
begin
  result:=self;
  brushStyle(1);
end;

function TEv3Screen.brushSolid: TEv3Screen;
begin
  result:=self;
  brushStyle(0);
end;

function TEv3Screen.brushBlack: TEv3Screen;
begin
  result:=self;
  with fcanvas.brush do begin
   FPColor := ev3blackColor;
  end;
end;

function TEv3Screen.brushWhite: TEv3Screen;
begin
  result:=self;
  with fcanvas.brush do begin
   FPColor := ev3WhiteColor;
  end;
end;

function TEv3Screen.penBig: TEv3Screen;
begin
  result:=self;
  fcanvas.pen.Width:=fcanvas.pen.Width+1;
end;

function TEv3Screen.penSmall: TEv3Screen;
begin
  result:=self;
  if fcanvas.pen.Width=1 then exit;
  fcanvas.pen.Width:=fcanvas.pen.Width-1;
end;

function TEv3Screen.penSize(size: variant): TEv3Screen;
begin
  result:=self;
  fcanvas.pen.Width:=size;
end;

function TEv3Screen.penStyle(style: variant): TEv3Screen;
begin
  result:=self;
  fcanvas.pen.style:=style;
end;

function TEv3Screen.penSolid: TEv3Screen;
begin
  result:=self;
  penstyle(psSolid);
end;

function TEv3Screen.penNone: TEv3Screen;
begin
  result:=self;
  penstyle(psClear);
end;

function TEv3Screen.penStd: TEv3Screen;
begin
  result:=self;
  with fcanvas.pen do begin
   mode := pmCopy;
   style := psSolid;
   width := 1;
   FPColor := ev3blackColor;
  end;
end;

function TEv3Screen.penBlack: TEv3Screen;
begin
  result:=self;
  fcanvas.pen.FPColor := ev3blackColor;
end;

function TEv3Screen.penWhite: TEv3Screen;
begin
  result:=self;
  fcanvas.pen.FPColor := ev3WhiteColor;
end;

function TEv3Screen.fontBig: TEv3Screen;
begin
  result:=self;
  ffont.size:=ffont.size+1;
end;

function TEv3Screen.fontSmall: TEv3Screen;
begin
  result:=self;
  ffont.size:=ffont.size-1;
end;

function TEv3Screen.fontRotate(angle: variant): TEv3Screen;
begin
  result:=self;
  ffont.angle:=(2*pi/360)*angle;
end;

function TEv3Screen.fontSize(size: variant): TEv3Screen;
begin
  result:=self;
  ffont.size:=size;
end;

function TEv3Screen.fontStd(): TEv3Screen;
begin
  result:=self;
  with ffont do begin
   AntiAliased:=false;
   Name:=fontName;
   Size:=14;
   FPColor:=ev3BlackColor;
  end;
end;

function TEv3Screen.fontBlack: TEv3Screen;
begin
  result:=self;
  ffont.FPColor:=ev3BlackColor;
end;

function TEv3Screen.fontWhite: TEv3Screen;
begin
  result:=self;
  ffont.FPColor:=ev3WhiteColor;
end;


procedure init; begin hideCursor(); createFB(); ev3Screen:=TEv3Screen.create(); end;
procedure done; begin ev3screen.free; destroyFB(); showCursor(); end;

initialization
   PushInit(@init);
   PushDone(@done);
end.

