{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Обработка аудио-системы контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}
{$SMARTLINK ON}
{$mode objfpc}
unit rubiroSound;
interface
 uses unix;
type
  { TEv3Sound }
  TEv3Sound=class
    private
      beepProcess:cint;
      playProcess:cint;
      speakInProcess,speakOutProcess:cint;
      stopBeforeStart:boolean;
      fspeakSpeed:integer;
    protected
    public
      constructor create;
      destructor destroy;override;
      // Устанавливает уровень громкости (от 0 до 100%)
      function volume(vol:variant):TEv3Sound;
      {
       Подает звуковой сигнал заданной частоты, заданной длительности, с заданной паузой
       по окончании. Длительность по умолчанию = 200мс, пауза - 0мс
      }
      function beep(tone:variant):TEv3Sound; // -f tone -l duration -D delay -n
      function beep(tone:variant;duration:variant):TEv3Sound; // -f tone -l duration -D delay -n
      function beep(tone:variant;duration:variant;delay:variant):TEv3Sound; // -f tone -l duration -D delay -n
      //             450           200              0
      {
       Подает набор звуковых сигналов заданной частоты, заданной длительности, с заданной задержкой
       по окончании. Информация о сигналах передается в массив тройками частота-длительность-пауза.
      }
      function beep(tdws:array of const):TEv3Sound; // тройки частота-длительность-пауза
      // Озвучивает файл в WAV-формате, имя которого передается в функцию
      function play(wavfile:variant):TEv3Sound;
      {
       Озвучивает переданный текст синтезатором речи,
       скорость по умолчанию = 160 слов в минуту
      }
      function speak(txt:variant):TEv3Sound; //speed=160
      function speak(txt:variant; speed:variant):TEv3Sound; //speed=160
      function speak(txts:array of const):TEv3Sound;
      function speak(txts:array of const; speed:variant):TEv3Sound;
      // устанавливает кол-во слов в минуту для синтезатора речи
      function setSpeakSpeed(speed:variant):TEv3Sound;
      // Ожидает завершения любых запущенных звуковых процессов
      function wait():TEv3Sound; // all
      {
        Ожидает завершения запущенных звуковых процессов
        Параметр what определяет тип процессов:
        'all' - все звуковые процессы
        'beep' - звуковой сигнал
        'play' - озвучивание WAV-файла
        'speak' - синтезатор речи
      }
      function wait(what:variant):TEv3Sound; // all, beep, play или speak
      // Прерывает все запущенные звуковые процессы
      function stop():TEv3Sound; // all, beep, play или speak
      // Прерывает запущенные звуковые процессы, параметр what - см. wait()
      function stop(what:variant):TEv3Sound; // all, beep, play или speak
      {
       устанавливает режим ожидания завершения звукового процесса перед
       стартом нового звукового процесса такого-же типа. Используется
       по умолчанию
      }
      function setWaitBeforeStart():TEv3Sound; // default
      {
       устанавливает режим прерывания звукового процесса перед
       стартом нового звукового процесса такого-же типа.
      }
      function setStopBeforeStart():TEv3Sound;
  end;

var ev3Sound:TEv3Sound=nil;

implementation
uses uev3,baseunix,sysutils,variants,uev3const,uev3func;

{ TEv3Sound }

constructor TEv3Sound.create;
begin
  inherited create;
  beepProcess:=0;
  playProcess:=0;
  speakInProcess:=0;
  speakOutProcess:=0;
  stopBeforeStart:=false;
  fspeakSpeed:=160;
end;

destructor TEv3Sound.destroy;
begin
  stop('all');
  inherited destroy;
end;

function TEv3Sound.volume(vol: variant): TEv3Sound;
begin
 result:=self;
 fpsystem('amixer -q set Master '+varToStr(vol)+'%'+devnull);
 fpsystem('amixer -q set Playback '+varToStr(vol)+'%'+devnull);
end;

function TEv3Sound.beep(tone: variant): TEv3Sound;
begin
  result:=self;
  beep([tone,200,0]);
end;

function TEv3Sound.beep(tone: variant; duration: variant): TEv3Sound;
begin
   result:=self;
   beep([tone,duration,0]);
end;

function TEv3Sound.beep(tone: variant; duration: variant; delay: variant
  ): TEv3Sound;
begin
   result:=self;
   beep([tone,duration,delay])
end;

function TEv3Sound.beep(tdws: array of const): TEv3Sound;
   Var I : longint;
     //  s:string;
       a:array of ansistring;
 begin
     result:=self;
     if High(tdws)<0 then exit;
     a:=nil;
//     -f tone -l duration -D delay -n
     i:=0;
     while i<=High(tdws) do begin
       push(a,'-f');
       push(a,arg2string(tdws[i]));
       push(a,'-l');
       push(a,arg2string(tdws[i+1]));
       push(a,'-D');
       push(a,arg2string(tdws[i+2]));
       push(a,'-n');
       inc(i,3);
     end;
     pop(a);
     //writeln('--- ',ptrint(self));
     if beepProcess<>0 then begin
       if stopBeforeStart then stop('beep')
       else wait('beep');
     end;
     beepProcess:=startProcess('/usr/bin/beep',a);
 end;

function TEv3Sound.play(wavfile: variant): TEv3Sound;
begin
    result:=self;
    if playProcess<>0 then begin
      if stopBeforeStart then stop('play')
      else wait('play');
    end;
    playProcess:=startProcess('/usr/bin/aplay', ['-q',vartostr(wavfile)]);
end;

function TEv3Sound.speak(txt: variant): TEv3Sound;
begin
  result:=self;
  speak([txt],fspeakspeed);
end;

function TEv3Sound.speak(txt: variant; speed: variant): TEv3Sound;
begin
    result:=self;
    speak([txt],speed);
end;

function TEv3Sound.speak(txts: array of const): TEv3Sound;
begin
  result:=self;
  speak(txts,fspeakspeed);
end;

function TEv3Sound.speak(txts: array of const; speed: variant): TEv3Sound;
Var I : longint;
    s:string;
    a1:array of ansistring;
begin
  result:=self;
  s:='';
  if High(txts)<0 then exit;
  a1:=nil;
  push(a1,'-s');
  push(a1,varToStr(speed));
  push(a1,'-a');
  push(a1,'200');
  push(a1,'-v');
  push(a1,'ru');
  push(a1,'--stdout');
  for i:=0 to High(txts) do begin
    s:=s+arg2string(txts[i])+' ';
  end;
  push(a1,'"'+s+'"');

  if speakInProcess<>0 then begin
    if stopBeforeStart then stop('speak')
    else wait('speak');
  end;

  StartPipedProcess('/usr/bin/espeak',a1,'/usr/bin/aplay',[],speakInProcess,speakOutProcess);

end;

function TEv3Sound.wait: TEv3Sound;
begin
  result:=self;
  wait('all');
end;

function TEv3Sound.wait(what: variant): TEv3Sound;
begin
  result:=self;
  case vartostr(what) of
   'all': begin wait('beep'); wait('play'); wait('speak'); end;
   'speak':begin
     if speakInprocess<>0 then begin
      fpWaitPid(speakInprocess,nil,0);
      fpWaitPid(speakOutprocess,nil,0);
      speakInprocess:=0;
      speakOutprocess:=0;
     end;
   end;
   'play': begin
     if playprocess<>0 then fpWaitPid(playprocess,nil,0);
     playprocess:=0;
   end;
   'beep': begin
     if beepprocess<>0 then fpWaitPid(beepprocess,nil,0);
     beepprocess:=0;
   end;
  end;
end;

function TEv3Sound.stop: TEv3Sound;
begin
  result:=self;
  stop('all');
end;

function TEv3Sound.stop(what: variant): TEv3Sound;
begin
  result:=self;
  case vartostr(what) of
   'all': begin stop('beep'); stop('play'); stop('speak'); end;
   'speak': begin
     if speakInprocess<>0 then begin
      //writeln('pkill ',playprocess);
      try killProcess(speakInprocess); except end;
      //fpwaitpid(speakInprocess,nil,0);
      try killProcess(speakOutprocess); except end;
      //fpwaitpid(speakOutprocess,nil,0);
      speakInprocess:=0;
      speakOutprocess:=0;
     end;
   end;
   'play': begin
     if playprocess<>0 then begin
      //writeln('pkill ',playprocess);
      try killProcess(playprocess); except end;
      //fpwaitpid(playprocess,nil,0);
     end;
     playprocess:=0;
   end;
   'beep': begin
     if beepprocess<>0 then begin
      try killProcess(beepprocess);except end;
      //fpwaitpid(beepprocess,nil,0);
     end;
     beepprocess:=0;
   end;
  end;

end;

function TEv3Sound.setWaitBeforeStart: TEv3Sound;
begin
       result:=self;
       stopBeforeStart:=false;
end;

function TEv3Sound.setStopBeforeStart: TEv3Sound;
begin
   result:=self;
   stopBeforeStart:=true;
end;

function TEv3Sound.setSpeakSpeed(speed: variant): TEv3Sound;
begin
  result:=self;
  fspeakSpeed:=speed;
end;


 procedure init; begin ev3Sound:=TEv3Sound.create(); end;
 procedure done; begin ev3Sound.free; end;

initialization
//  writeln(ptrint(@_pushinit));
//  writeln('------');
  PushInit(@init);
//  writeln('-------');
  PushDone(@Done);
end.

