{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Низкоуровневая поддержка датчиков и двигателей.
    Планируется поддержка других типов устройств.

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

{$SMARTLINK ON}
{$mode objfpc}
{$H+}

unit uev3Devices;

interface
uses uev3,uev3func,uev3SysFS,fgl;

// типы управляемых систем
type  TEv3DeviceSystem=(ev3dSensors,ev3dTahoMotors);
// определяющие каталоги для типов управляемых систем
const ev3DeviceSystems:array[TEv3DeviceSystem]of string[30]=
       ('/sys/class/lego-sensor','/sys/class/tacho-motor');

// все типы поддерживаемых устройств
type  TEv3DeviceType=(ev3tUnknownDevice,
            ev3tUltraSensor,ev3tGyroSensor,ev3tColorSensor,ev3tTouchSensor,ev3tInfraSensor,
            ev3tLTachoMotor,ev3tMTachoMotor);
      TEv3DeviceTypes=set of TEv3DeviceType;

// распределение типов устройств по системам
const ev3Devices:array[TEv3DeviceSystem] of TEv3DeviceTypes=(
       [ev3tUltraSensor,ev3tGyroSensor,ev3tColorSensor,ev3tTouchSensor,ev3tInfraSensor],
       [ev3tLTachoMotor,ev3tMTachoMotor]);

// идентификаторы типов устройств
const ev3DriverID:array[TEv3DeviceType]of string[20]=('unknown',
            'lego-ev3-us','lego-ev3-gyro','lego-ev3-color','lego-ev3-touch','lego-ev3-ir',
            'lego-ev3-l-motor','lego-ev3-m-motor'
            );
// все атрибуты устройств
type  TEv3DeviceAttribute=(
            ev3adriver_name,
            ev3aaddress,
            // sensors
            ev3abin_data,ev3abin_data_format,ev3acommand,ev3acommands,
            ev3adirect,ev3adecimals,ev3afw_version,
            ev3amode,ev3amodes,ev3anum_values,ev3apoll_ms,ev3aunits,
            ev3avalue0,ev3avalue1,ev3avalue2,ev3avalue3,ev3avalue4,ev3avalue5,
            ev3avalue6,ev3avalue7,ev3atext_value,
            // + motors
            ev3acount_per_rot,ev3acount_per_m,ev3afull_travel_count,
            ev3aduty_cycle,ev3aduty_cycle_sp,ev3apolarity,ev3aposition,
            ev3ahold_pid_Kd,ev3ahold_pid_Ki,ev3ahold_pid_Kp,
            ev3amax_speed,ev3aposition_sp,ev3aspeed,ev3aspeed_sp,ev3aramp_up_sp,ev3aramp_down_sp,
            ev3aspeed_pid_Kd,ev3aspeed_pid_Ki,ev3aspeed_pid_Kp,
            ev3astate,ev3astop_action,ev3astop_actions,ev3atime_sp
            );
      TEv3DeviceAttributes=set of TEv3DeviceAttribute;

const ev3DeviceAttributes:array[TEv3DeviceSystem] of TEv3DeviceAttributes=(
       [ev3adriver_name,ev3aaddress,ev3abin_data,ev3abin_data_format,ev3acommand,ev3acommands,
        ev3adirect,ev3adecimals,ev3afw_version,
        ev3amode,ev3amodes,ev3anum_values,ev3apoll_ms,ev3aunits,
        ev3avalue0,ev3avalue1,ev3avalue2,ev3avalue3,ev3avalue4,ev3avalue5,
        ev3avalue6,ev3avalue7,ev3atext_value],
       [ev3adriver_name,ev3aaddress,ev3acommand,ev3acommands,
        ev3acount_per_rot,ev3acount_per_m,ev3afull_travel_count,
        ev3aduty_cycle,ev3aduty_cycle_sp,ev3apolarity,ev3aposition,
        ev3ahold_pid_Kd,ev3ahold_pid_Ki,ev3ahold_pid_Kp,
        ev3amax_speed,ev3aposition_sp,ev3aspeed,ev3aspeed_sp,ev3aramp_up_sp,ev3aramp_down_sp,
        ev3aspeed_pid_Kd,ev3aspeed_pid_Ki,ev3aspeed_pid_Kp,
        ev3astate,ev3astop_action,ev3astop_actions,ev3atime_sp]
       );

// структура описания атрибута
type TEv3DataAttribute=record
      name:string[20]; // имя файла атрибута
      access:TEv3DataMode; // режим доступа к атрибуту
     end;

// описание атрибутов устройств
const ev3DeviceAttribute:array[TEv3DeviceAttribute]of TEv3DataAttribute=(

      (name:'driver_name'; access:ev3ReadOnly),(name:'address'; access:ev3ReadOnly),
      (name:'bin_data'; access:ev3ReadOnly),
      (name:'bin_data_format'; access:ev3ReadOnly),(name:'command'; access:ev3WriteOnly),
      (name:'commands'; access:ev3ReadOnly),(name:'direct'; access:ev3ReadWrite),
      (name:'decimals'; access:ev3ReadOnly),
      (name:'fw_version'; access:ev3ReadOnly),(name:'mode'; access:ev3ReadWrite),
      (name:'modes'; access:ev3ReadOnly),(name:'num_values'; access:ev3ReadOnly),
      (name:'poll_ms'; access:ev3ReadWrite),(name:'units'; access:ev3ReadOnly),
      (name:'value0'; access:ev3ReadOnly),(name:'value1'; access:ev3ReadOnly),
      (name:'value2'; access:ev3ReadOnly),(name:'value3'; access:ev3ReadOnly),
      (name:'value4'; access:ev3ReadOnly),(name:'value5'; access:ev3ReadOnly),
      (name:'value6'; access:ev3ReadOnly),(name:'value7'; access:ev3ReadOnly),
      (name:'text_value'; access:ev3ReadOnly),

      (name:'count_per_rot'; access:ev3ReadOnly),(name:'count_per_m'; access:ev3ReadOnly),
      (name:'full_travel_count'; access:ev3ReadOnly),(name:'duty_cycle'; access:ev3ReadOnly),
      (name:'duty_cycle_sp'; access:ev3ReadWrite),(name:'polarity'; access:ev3ReadWrite),
      (name:'position'; access:ev3ReadWrite),(name:'hold_pid/Kd'; access:ev3ReadWrite),
      (name:'hold_pid/Ki'; access:ev3ReadWrite),(name:'hold_pid/Kp'; access:ev3ReadWrite),
      (name:'max_speed'; access:ev3ReadOnly),(name:'position_sp'; access:ev3ReadWrite),
      (name:'speed'; access:ev3ReadOnly),(name:'speed_sp'; access:ev3ReadWrite),
      (name:'ramp_up_sp'; access:ev3ReadWrite),(name:'ramp_down_sp'; access:ev3ReadWrite),
      (name:'speed_pid/Kd'; access:ev3ReadWrite),(name:'speed_pid/Ki'; access:ev3ReadWrite),
      (name:'speed_pid/Kp'; access:ev3ReadWrite),(name:'state'; access:ev3ReadOnly),
      (name:'stop_action'; access:ev3ReadWrite),(name:'stop_actions'; access:ev3ReadOnly),
      (name:'time_sp'; access:ev3ReadWrite)
   );

type TEv3Port=(ev3pUnknown,in1,in2,in3,in4,outA,outB,outC,outD);
     TEv3PortSet=set of TEv3Port;
const ev3Port:array[TEv3port]of string[10]=('none','in1','in2','in3','in4','outA','outB','outC','outD');

type
    { TEv3Device }
    TEv3DeviceHelper=class;
    THelperList=specialize TFPGList<TEv3DeviceHelper>;
    TEv3Device=class(TEv3)
      private
       fhelpers:THelperList; // список подключенных к девайсу коннекторов
       fsystem:TEv3DeviceSystem;// сенсор или мотор
       fDevice:TEv3DeviceType;  // конкретный девайс
       fPort:TEv3Port;          // порт подключения
       fsysfs:shortstring;       // каталог к девайсу
       fattrs:array[TEv3DeviceAttribute] of TEv3Data; // все атрибуты текущей системы
       function Getattrs(index: TEv3DeviceAttribute): TEv3Data;
       function getConnected: boolean;
      public
       constructor Create(sysfs:ansistring);
       procedure refresh(sysfs:ansistring);
       destructor destroy;override;
       property Attrs[index:TEv3DeviceAttribute]:TEv3Data read Getattrs;
       property System:TEv3DeviceSystem read Fsystem;
       property Device:TEv3DeviceType read FDevice;
       property Port:TEv3Port read fPort;
       property Connected:boolean read getConnected;
    end;


    { TEv3DeviceFactoryEnum }
    TEv3DeviceFactory=class;
    // Энумератор для фабрики, возвращает только активные девайсы
    TEv3DeviceFactoryEnum=class
       private
        cPort:tev3Port;
        fDF:TEv3DeviceFactory;
       public
       constructor Create(DF:TEv3DeviceFactory);
       function GetCurrent:TEv3Device;
       function MoveNext:boolean;
       procedure Reset;
       property Current: TEv3Device read getCurrent;
    end;

    { TEv3DeviceFactory }

    TEv3DeviceFactory=class(TEv3)
     private
      fDevices:array[TEv3Port] of TEv3Device;
      procedure findDirs(const basedir:string; var sa:TAAstring);
      function getDeviceCount: integer;
      function GetDevices(index:TEv3Port): TEv3Device;
     public
      constructor Create();
      function GetEnumerator:TEv3DeviceFactoryEnum;
      {
        Обновляет список девайсов.

        Если freeLostDevices=false, то не уничтожает
        объекты девайсов в случае их физического отключения. Применяется
        по умолчанию для возможности переподключения устройств в ситуации
        незапланированого отключения. Недостаток - невозможность подключения
        физического девайса другого типа к этому-же порту, т.е. после первого
        обнаружения девайс фиксируется на конкретном порту и остается там до
        окончания программы. Отключение физического устройства может быть
        протестировано методом Connected. При попытке обращения к методам отключенных
        объектов, которые получают доступ к устройству, система пытается
        uev3sysfs.countMaxRefreshFactory переподключить отключенное устройство
        с интервалом в uev3sysfs.errorAttrInterval миллисекунд между попытками
        и звуковой сигнализацией, регулируемой uev3sysfs.beepError. При успешном
        переподключении программа продолжает свою работу. В случа неудачи - возникает
        Exception.

        Если freeLostDevices=true, то уничтожает объекты девайсов в случае
        их физического отключения. Недостаток - после выполнения операции ВСЕ
        объекты датчиков и моторов должны быть протестированы на подключенность
        методом Connected. Отключенные объекты должны быть уничтожены и при
        необходимости - пересозданы. При попытке обращения к методам отключенных
        объектов, которые получают доступ к устройству, возникает Exception.
      }
      procedure Refresh(freeLostDevices:boolean=false);
      destructor Destroy;override;
      property Devices[index:TEv3Port]:TEv3Device read GetDevices;
      property DeviceCount:integer read getDeviceCount;
    end;


    { TEv3DeviceHelper }

    { TTryConnect }

    TTryConnect=class
      Device:TEv3DeviceType;
      Port,RealPort:TEv3Port;
      Number:integer; // номер по порядку передачи
      constructor Create(_Device:TEv3DeviceType;_Port,_RealPort:TEv3Port;_Number:integer);
    end;
    TTryConnectList=specialize TFPGObjectList<TTryConnect>;

    // Энумератор для для коннектора, возвращает все девайсы

    { TEv3DeviceHelperEnum }

    TEv3DeviceHelperEnum=class
       private
        cPort:tev3Port;
        fDH:TEv3DeviceHelper;
       public
       constructor Create(DH:TEv3DeviceHelper);
       function GetCurrent:TEv3Device;
       function MoveNext:boolean;
       procedure Reset;
       property Current: TEv3Device read getCurrent;
    end;

    TEv3DeviceHelper=class(TEv3) // коннектор к набору девайсов
     private
     protected
      procedure Configure(devices:array of const);
      // девайс сообщает хелперу, что он обновился после реконнекта
      // нужно для повторной установки текущего режима после реинициализации
      procedure deviceRefreshed(dev:TEv3Device);virtual;
     public
      FailDevices:TTryConnectList;// неудачные соединения
      UpDevices:TTryConnectList; // поднявшиеся соединения
      AllDevices:TTryConnectList; // все соединения, отсортированные по порядку передачи
      DS:TEv3PortSet; // множество обрабатываемых девайсов, индексы от фабрики
      {
       ожидает пары типдевайса-порт
       ищет в фабрике, формирует DS
       Если порт=none, берет первый
       девайс заявленного типа, к которому подключено
       минимальное количество хэлперов
      }
      constructor Create(devices:array of const);
      constructor Create(devType:TEv3DeviceType; port:TEv3Port);
      constructor Create(devType1:TEv3DeviceType; port1:TEv3Port;
                         devType2:TEv3DeviceType; port2:TEv3Port);
      procedure setIntervals(R,W:integer);virtual;abstract;
      destructor Destroy;override;
      function Success:boolean; // все соединения прошли удачно
      {
       все девайсы физически подключены
      }
      function Connected:boolean;

      class function varToPort(port:variant):TEv3Port;
      class function varToDevice(Device:variant):TEv3DeviceType;

      function GetEnumerator:TEv3DeviceHelperEnum;
      //procedure wait()
    end;


    { TEv3OneDeviceHelper }
    TEv3OneDeviceHelperClass=class of TEv3OneDeviceHelper;
    TEv3OneDeviceHelper=class(TEv3DeviceHelper)
    private
      function getData: Tev3Data;
      function getEv: Tev3Device;
      function getPort: TEv3Port;
      protected
       {
        в потомках должен возвращать тип девайса, который будет использоваться для
        создания объекта
       }
       class function deviceType:TEv3DeviceType;virtual;
       {
        вызывается в конструкторе после создания объекта
       }
//       procedure afterConstruction;virtual;
      public
      property ev:Tev3Device read getEv;
      property Data:Tev3Data read getData;
      property port:TEv3Port read getPort;

      constructor create(_port:variant);
      constructor create();
    end;

    { TEv3TwoDeviceHelper }

    TEv3TwoDeviceHelper=class(TEv3OneDeviceHelper)
    private
      function getData2: Tev3Data;
      function getEv2: Tev3Device;
      protected
       property ev2:Tev3Device read getEv2;
       property Data2:Tev3Data read getData2;
      public
      constructor create(device:variant; _port:variant; device2:variant; _port2:variant);
    end;

    Ev3OtherDeviceException=class(Ev3Exception)
    end;


var ev3DeviceFactory:TEv3DeviceFactory;
function ev3Helper(index: integer; helperClass:TEv3OneDeviceHelperClass; refreshFactory:boolean=false): TEv3OneDeviceHelper;

//procedure init;
//procedure done;

implementation
uses
  SysUtils,Unix,variants,uev3utf8;

var ev3Helpers:array[TEv3Port]of TEv3OneDeviceHelper=(nil, nil,nil,nil,nil, nil,nil,nil,nil);

{ Возвращает
  1..8 - заявленное устройство по номеру порта
  -1..-4 - заявленное устройство по порядку подключения
  (-1 - первое устройство, -2 - второе устройство ... )
  остальные значения, либо нет заявленного устройства - nil
}
function ev3Helper(index: integer; helperClass:TEv3OneDeviceHelperClass; refreshFactory:boolean=false): TEv3OneDeviceHelper;
  var i,cnt:integer; p:TEv3Port;
 begin
   if not (abs(index) in [1..8]) then exit(nil);
   if refreshFactory then ev3DeviceFactory.refresh;
   if index<0 then begin
     // берем по порядку
     cnt:=1;
     for p:=in1 to outD do begin
    //  writeln(p);
      if not assigned(ev3DeviceFactory.Devices[p]) then continue;
      if ev3DeviceFactory.Devices[p].Device=helperClass.deviceType then begin
        if cnt=abs(index) then exit(ev3Helper(ord(p),helperClass));
        inc(cnt);
      end;
     end;
     if refreshFactory then exit(nil)
     else exit(ev3Helper(index,helperClass,true));
   end;
   // иначе берем по номеру порта
   if ev3helpers[tev3port(index)] is helperClass then exit(ev3helpers[tev3port(index)]);
   result:=helperClass.create(index);
   if not result.connected then begin
     result.Free;
     if refreshFactory then exit(nil)
     else exit(ev3helper(index,helperClass,true));
   end;
   ev3helpers[tev3port(index)]:=result;
  end;




{ TEv3TwoDeviceHelper }

function TEv3TwoDeviceHelper.getData2: Tev3Data;
begin
 result:=ev2.Attrs[ev3avalue0];
end;

function TEv3TwoDeviceHelper.getEv2: Tev3Device;
begin
 result:=ev3DeviceFactory.Devices[allDevices[1].realport];
end;

constructor TEv3TwoDeviceHelper.create(device: variant; _port: variant;
  device2: variant; _port2: variant);
begin
 Tev3DeviceHelper.create([varToDevice(device),varToPort(_port),varToDevice(device2),varToPort(_port2)]);
end;

{ TEv3OneDeviceHelper }

function TEv3OneDeviceHelper.getData: Tev3Data;
begin
  if not assigned(self) then exit(nil);
  result:=ev.Attrs[ev3avalue0];
end;

function TEv3OneDeviceHelper.getEv: Tev3Device;
begin
 if not assigned(self) then exit(nil);
 result:=ev3DeviceFactory.Devices[allDevices[0].realport];
end;

function TEv3OneDeviceHelper.getPort: TEv3Port;
begin
  if not assigned(self) then exit(ev3pUnknown);
  result:=allDevices[0].realport;
end;

class function TEv3OneDeviceHelper.deviceType: TEv3DeviceType;
begin
   result:=ev3tUnknownDevice;
end;


constructor TEv3OneDeviceHelper.create();
begin
 create(varToPort(ev3pUnknown));
end;

constructor TEv3OneDeviceHelper.create(_port: variant);
begin
 inherited create(deviceType(),varToPort(_port));
end;

{ TEv3DeviceHelperEnum }

constructor TEv3DeviceHelperEnum.Create(DH: TEv3DeviceHelper);
begin
  inherited create;
  fdh:=DH;
  reset;
end;

function TEv3DeviceHelperEnum.GetCurrent: TEv3Device;
begin
 result:=ev3DeviceFactory.Devices[cPort];
end;

function TEv3DeviceHelperEnum.MoveNext: boolean;
begin
 result:=false;
 if cport=high(cport) then exit;
 repeat
  inc(cport);
  if (cport in fdh.DS) then exit(true);
 until cport=high(cport);

end;

procedure TEv3DeviceHelperEnum.Reset;
begin
 cPort:=ev3pUnknown;
end;

{ TTryConnect }

constructor TTryConnect.Create(_Device: TEv3DeviceType; _Port,_RealPort: TEv3Port;
  _Number: integer);
begin
  inherited create;
  Device:=_Device;
  Port:=_Port;
  RealPort:=_RealPort;
  Number:=_Number;
end;

{ TEv3DeviceHelper }
 function compare(const item1,item2:TTryConnect):integer;
  begin
    result:=Item1.Number-item2.Number;
  end;

procedure TEv3DeviceHelper.Configure(devices: array of const);

  var i:integer;
    TypeDev:TEv3DeviceType;  // конкретный девайс
    Port:TEv3Port;    // порт подключения
    Number:integer;
    ev,minEV:TEv3Device;
    found:boolean;
 begin
  if assigned(failDevices) then failDevices.Free;
  if assigned(upDevices) then upDevices.Free;
  if assigned(allDevices) then allDevices.Free;
  for p in DS do ev3DeviceFactory.Devices[p].fhelpers.Remove(self);
  failDevices:=TTryConnectList.Create;// FailDevices.FreeObjects:=true;
  upDevices:=TTryConnectList.Create; // upDevices.FreeObjects:=true;
  allDevices:=TTryConnectList.Create; // allDevices.FreeObjects:=true;
  i:=0;
  // сначала подключение к девайсам с жестко зафиксированными портами
  while i<=High(devices) do begin
     TypeDev:=TEv3DeviceType(arg2int(devices[i]));
     Port:=TEv3Port(arg2int(devices[i+1]));
     Number:=i div 2;
     inc(i,2);
     if port=ev3pUnknown then continue;
     found:=false;
     for ev in ev3DeviceFactory do begin
      if (ev.Port=Port)
         and(ev.Device=TypeDev) then begin
          Include(DS,ev.Port);
          ev.fhelpers.Add(self);
          found:=true;
          break;
         end;
     end;
     if not found then failDevices.add(TTryConnect.Create(typeDev,Port,Port,Number))
     else upDevices.add(TTryConnect.Create(typeDev,Port,Port,Number));
     allDevices.add(TTryConnect.Create(typeDev,Port,Port,Number));
  end;
  i:=0;
  // теперь подключение к девайсам с плавающими портами
  while i<=High(devices) do begin
     TypeDev:=TEv3DeviceType(arg2int(devices[i]));
     Port:=TEv3Port(arg2int(devices[i+1]));
     Number:=i div 2;
     inc(i,2);
     if port<>ev3pUnknown then continue;
     minev:=nil;
     for ev in ev3DeviceFactory do begin
      if (ev.Device=TypeDev)and(not (ev.port in DS)) then begin
         if minev=nil then minev:=ev
         else begin
          // подключаться к девайсу, имеющему минимальное кол-во коннекторов
          // в идеале - 0
          if ev.fhelpers.count<minev.fhelpers.count then minev:=ev;
         end;
      end;
     end;
     if minev<>nil then begin
      Include(DS,minev.Port);
      minev.fhelpers.Add(self);
      upDevices.add(TTryConnect.Create(typeDev,Port,minev.Port,Number));
      allDevices.add(TTryConnect.Create(typeDev,Port,minev.Port,Number));
     end
     else begin
      failDevices.add(TTryConnect.Create(typeDev,Port,Port,Number));
      allDevices.add(TTryConnect.Create(typeDev,Port,Port,Number));
     end;
  end;
  allDevices.sort(@compare);
 end;

constructor TEv3DeviceHelper.Create(devices: array of const);
begin
 inherited create;
 Configure(devices);
end;

constructor TEv3DeviceHelper.Create(devType: TEv3DeviceType; port: TEv3Port);
begin
  inherited create;
  Configure([devType,Port]);
end;

constructor TEv3DeviceHelper.Create(devType1: TEv3DeviceType; port1: TEv3Port;
  devType2: TEv3DeviceType; port2: TEv3Port);
begin
 inherited create;
 Configure([devType1,Port1,devType2,Port2]);
end;

destructor TEv3DeviceHelper.Destroy;
 var p:TEv3Port;// t:ttryconnect;
begin
// writeln('---',connected,'-----');
 if connected then setIntervals(setInterval,getInterval);
//  for t in failDevices do t.free;
//  writeln('bef ');
  failDevices.free;
//  for t in upDevices do t.free;
  updevices.free;
// for t in allDevices do t.free;
  allDevices.free;
  for p in DS do
    if assigned(ev3DeviceFactory.Devices[p])and assigned(ev3DeviceFactory.Devices[p].fhelpers) then begin
//     writeln('bef ',p);
     ev3DeviceFactory.Devices[p].fhelpers.Remove(self);
//     writeln('aft ',p);
    end;
//  writeln('aft ');
  inherited Destroy;
end;

function TEv3DeviceHelper.Success: boolean;
begin
 if not assigned(self) then exit(false);
 result:=failDevices.Count=0;
end;

function TEv3DeviceHelper.Connected: boolean;
 var ev:TEv3Device; evFound:boolean;
begin
  if not assigned(self) then exit(false);
  connected:=false;
  evFound:=false;
  for ev in self do begin
     evFound:=true;
     if not assigned(ev) then exit;
     if not ev.connected then exit;
  end;
  connected:=evFound;
end;

procedure TEv3DeviceHelper.deviceRefreshed(dev: TEv3Device);
begin
 dev:=dev;
 // перекрывать в потомках, где надо ввостановить режим работы девайса
end;

class function TEv3DeviceHelper.varToPort(port: variant): TEv3Port;
begin
  case trim(utf8lowercase(varToStr(port))) of
  '1','in1':result:=in1;
  '2','in2':result:=in2;
  '3','in3':result:=in3;
  '4','in4':result:=in4;
  '5','outa','a':result:=outa;
  '6','outb','b':result:=outb;
  '7','outc','c':result:=outc;
  '8','outd','d':result:=outd;
  else result:=ev3pUnknown;
 end;
end;

class function TEv3DeviceHelper.varToDevice(Device: variant): TEv3DeviceType;
begin
 case trim(utf8lowercase(varToStr(Device))) of
  '0','ultra','ультра':result:=ev3tUltraSensor;
  '1','gyro','гиро':result:=ev3tGyroSensor;
  '2','color','цвет':result:=ev3tColorSensor;
  '3','touch','кнопка':result:=ev3tTouchSensor;
  '4','infra','инфра':result:=ev3tInfraSensor;
  '5','lmotor','largemotor','большой':result:=ev3tLTachoMotor;
  '6','mmotor','meduimmotor','средний':result:=ev3tMTachoMotor;
 end;
end;


function TEv3DeviceHelper.GetEnumerator: TEv3DeviceHelperEnum;
begin
  result:=TEv3DeviceHelperEnum.Create(self);
end;

{ TEv3DeviceFactoryEnum }

constructor TEv3DeviceFactoryEnum.Create(DF: TEv3DeviceFactory);
begin
  inherited Create;
  fdf:=df;
end;

function TEv3DeviceFactoryEnum.GetCurrent: TEv3Device;
//function TEv3DeviceFactoryEnum.GetCurrent: TObject;
begin
  while true do begin;
   result:=fdf.fdevices[cPort];
   if (not Assigned(fdf.fdevices[cPort]))or(not fdf.fdevices[cPort].connected) then begin
    inc(cPort);continue;
   end;
   break;
  end;
end;

function TEv3DeviceFactoryEnum.MoveNext: boolean;
 var k:tEv3Port; dev:TEv3Device; found:boolean;
begin
 result:=false; found:=false;
 if cPort=high(cPort) then exit;
 for k:=succ(cPort) to high(k) do begin
  dev:=fdf.fdevices[k];
  if (Assigned(dev))and(dev.connected) then begin
   found:=true;break
  end;
 end;
 if found then begin
  result:=true; cport:=k;
 end;
end;

procedure TEv3DeviceFactoryEnum.Reset;
begin
 cport:=ev3pUnknown;
end;

{ TEv3DeviceFactory }

procedure TEv3DeviceFactory.findDirs(const basedir: string; var sa: TAAstring);
Var Info : TSearchRec;
    //s:ansistring;
Begin
 //writeln('find');
 //  sa:=nil;
  If FindFirst (basedir+'/*',faAnyFile and faDirectory,Info)=0 then
    begin
    Repeat
      With Info do
        If ((Attr and faDirectory) = faDirectory)and(name<>'.')and(name<>'..')
           then begin
            push(sa,basedir+'/'+name);
            //s:=basedir+'/'+name;
            //push(sa,s);
           end;
    Until FindNext(info)<>0;
    FindClose(Info);
    end;
   // writeln(length(sa));
end;

function TEv3DeviceFactory.getDeviceCount: integer;
 var k:TEv3Port;
begin
  result:=0;
  for k in TEv3Port do
   if assigned(fdevices[k]) and (fdevices[k].connected) then
    inc(result);
end;

function TEv3DeviceFactory.GetDevices(index: TEv3Port): TEv3Device;
begin
  result:=fDevices[index];
end;

constructor TEv3DeviceFactory.Create;
begin
  inherited create;
  refresh;
end;

function TEv3DeviceFactory.GetEnumerator: TEv3DeviceFactoryEnum;
//function TEv3DeviceFactory.GetEnumerator: IEnumerator;
begin
  result:=TEv3DeviceFactoryEnum.Create(self);
end;


procedure TEv3DeviceFactory.Refresh(freeLostDevices: boolean);
 var i:TEv3DeviceSystem; dev:TEv3Device;
     k:TEv3Port;found:boolean;
     sa:TAAstring;
     si:integer;
begin
 sa:=nil;
 for i:=low(i) to high(i) do
  finddirs(ev3DeviceSystems[i],sa);

 for si:=0 to length(sa)-1 do begin
  found:=false;
  for k in TEv3Port do begin
   if assigned(fdevices[k]) and (sa[si]=fdevices[k].fsysfs) then begin
     found:=true; break;
   end;
  end;
  if not found then begin
   dev:=TEv3Device.Create(sa[si]);
   if not assigned(fDevices[dev.port]) then
    fDevices[dev.port]:=dev//TEv3Device.Create(sa[si])
   else begin
    fDevices[dev.port].refresh(sa[si]);
    dev.free;
   end;
  end;
 end;
 if freeLostDevices then
  for k in TEv3Port do begin
   if assigned(fdevices[k]) and (not fdevices[k].Connected) then freeandnil(fdevices[k]);
  end;

// for si:=0 to length (sa)-1 do begin
//  sa[si]:='';
// end;
// setlength(sa,0);
end;

destructor TEv3DeviceFactory.Destroy;
 var k:TEv3Port;
begin
 for k in TEv3Port do freeAndNil(fDevices[k]);
 inherited destroy;
end;

{ TEv3Device }

function TEv3Device.Getattrs(index: TEv3DeviceAttribute): TEv3Data;
begin
 result:=fattrs[index];
end;

function TEv3Device.getConnected: boolean;
begin
//  writeln(fsysfs);
  result:=directoryExists(fsysfs);
end;

constructor TEv3Device.Create(sysfs: ansistring);
 var i:TEv3DeviceSystem; m:TEv3DeviceType; n:TEv3Port; s:string;
     k:TEv3DeviceAttribute;
begin
  inherited Create;
  fhelpers:=THelperList.Create;

  for k:=low(k) to high(k) do fattrs[k]:=nil;


  for i:=low(i) to high(i) do
    if pos(ev3DeviceSystems[i],sysfs)=1 then fsystem:=i;

  refresh(sysfs);

  s:=fattrs[ev3adriver_name].sData;
  for m:=low(m) to high(m) do
   if ev3DriverID[m]=s then fdevice:=m;

  s:=fattrs[ev3aaddress].sData;
  for n in TEv3Port do
   if ev3Port[n]=s then fport:=n;
end;

procedure TEv3Device.refresh(sysfs: ansistring);
 var k:TEv3DeviceAttribute;
     newDevice:boolean; s:string; m:TEv3DeviceType;
     dh:TEv3DeviceHelper;
begin
   newDevice:=fsysfs='';
   if not newDevice then writeln('NoT NEW!!');
   fsysfs:=sysfs;
   for k:=low(k) to high(k) do begin
    if k in ev3DeviceAttributes[fsystem] then begin
     with ev3DeviceAttribute[k] do begin
      if fileexists(sysfs+'/'+name) then begin
       if assigned(fattrs[k]) then
        fattrs[k].reopen(sysfs+'/'+name)
       else
        fattrs[k]:=TEv3Data.Create(sysfs+'/'+name,self,access);
      end
      else begin
       fattrs[k].free;
       fattrs[k]:=nil;
      end;
     end;
    end;
  end;
  if not newDevice then begin // вызвано внешним обновлением
   s:=fattrs[ev3adriver_name].sData;
   for m:=low(m) to high(m) do
    if ev3DriverID[m]=s then
     if fdevice<>m then
      raise Ev3OtherDeviceException.create('Reconnected Device want '+ev3DriverID[fdevice]
            +', but get '+s);

  for dh in fhelpers do dh.deviceRefreshed(self);
  end;

end;

destructor TEv3Device.destroy;
  var k:TEv3DeviceAttribute;
begin
 for k:=low(k) to high(k) do begin
  if assigned(fattrs[k])then fattrs[k].free;
 end;
 fhelpers.free;
 inherited destroy;
end;

procedure init; begin ev3DeviceFactory:=TEv3DeviceFactory.create; end;
procedure done;
 var i:TEv3Port;
begin
// writeln('devf+');
 for i:=low(i) to high(i) do
  if assigned(ev3Helpers[i]) then freeAndNil(ev3Helpers[i]);
 freeAndNil(ev3DeviceFactory);
// writeln('devf-');
end;

initialization
 PushInit(@init);
 PushDone(@Done);
end.
