{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Класс чтения-записи данных для sysfs-файлов

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}
{$SMARTLINK ON} 
{$mode objfpc}
{$H+}
unit uev3sysfs;


interface
uses uev3,SysUtils;

var
    // ms между двумя установками значения. Если интервал не истек, блокируется до истечения
    setInterval:word=20;
    // ms между двумя получениями значения. Если интервал не истек, возвращает старое значение
    getInterval:word=10;
    // ms - время слипа после получения ошибки при доступе к не до конца
    // инициализированному датчику/мотору
    errorInitInterval:word=3000;
    // ms - время слипа после получения ошибки при доступе атрибуту перед
    // перед попыткой повторной инициализацией фабрики
    errorAttrInterval:word=2000;
    // максимальное количество попыток инициализации фабрики
    countMaxRefreshFactory:word=10;
    // подавать сигналы при отключении, тон зависит от порта, длительность - от номера сигнала
    beepError:boolean=true;

type
    TEv3DataMode=(ev3ReadOnly,ev3WriteOnly,ev3ReadWrite);

    { TEv3Data }

    TEv3Data=class(TEv3)
      private
       f:longint;
       fowner:TObject;
       Fmode: TEv3DataMode;
       fWriteInterval,fReadInterval:longint;
       fn:string;
       e:longint;
       prevData,prevGetData:string;
       //prevTime,prevGetTime:TDateTime;
       function getiData: longint;
       function getsData: string;
       function getwiData: longint;
       function getwsData: string;
       procedure setiData(AValue: longint);
       procedure Setmode(AValue: TEv3DataMode);
       procedure setsData(AValue: string);
       procedure setwiData(AValue: longint);
       procedure setwsData(AValue: string);
       procedure beepE(port:word; len:word);
       function endGetInterval:boolean;
      public
       skipInterval:boolean;
       function waitEvent(event:string; timeout:dword=high(dword)):boolean; override;
       constructor Create(filename:string; owner:TObject=nil;_mode:TEv3DataMode=ev3ReadOnly);
       procedure setIntervals(R,W:integer);
       procedure Reopen(filename:string);
       destructor destroy;override;
       property mode:TEv3DataMode read Fmode write Setmode;
       property sData:string read getsData write setsData;
       property iData:longint read getiData write setiData;
       property wsData:string read getwsData write setwsData;
       property wiData:longint read getwiData write setwiData;
       procedure hardPutData(data:shortstring);
    end;

    Ev3Exception=class(Exception)
    end;

    Ev3OpenException=class(Ev3Exception)
    end;

    Ev3ReadException=class(Ev3Exception)
    end;

    Ev3WriteException=class(Ev3Exception)
    end;

implementation
uses
  BaseUnix,Unix,errors,dateutils,uev3Devices,rubiroSound;

{ TEv3Data }

function TEv3Data.getiData: longint;
begin
 try
  result:=strtoint(sData);
 except
  result:=0;
 end;
end;

function TEv3Data.getsData: string;
var buf:shortstring;
    cnt:integer;
begin
//  writeln(f);
 if not endGetInterval then exit(prevGetData);
 buf:='';
 cnt:=0;
 while true do begin
  inc(cnt);// writeln('---- ',cnt);
  fpseterrno(0);
  buf[0]:=chr(fppread(f,buf[1],255,0));
  dec(buf[0]);
  result:=buf;
  prevGetData:=result;
  e:=fpgeterrno;
  if (e=0)or(ev3Finalized) then break;
  if (cnt>=countMaxRefreshFactory)or(fowner=nil) then begin
    raise ev3ReadException.create('TEv3Data Read Error: file - '+fn+' ; errorcode - '+inttostr(e)+' ; '+strerror(e));
  end;
  // произошел дисконнект, обновляем фабрику, пока устройство снова не подключится
  if beeperror then beepE(ord((fowner as tev3Device).Port),600 div cnt);
  sleep(errorAttrInterval);
  ev3DeviceFactory.Refresh;
 end;
end;

function TEv3Data.getwiData: longint;
begin
 result:=strtoint(wsData);
end;

function TEv3Data.getwsData: string;
begin
 waitEvent('',high(dword));
 result:=prevdata;
end;

procedure TEv3Data.setiData(AValue: longint);
begin
  sdata:=inttostr(Avalue);
end;

procedure TEv3Data.Setmode(AValue: TEv3DataMode);
begin
  if Fmode=AValue then Exit;
  Fmode:=AValue;
  reopen(fn);
end;

procedure TEv3Data.setsData(AValue: string);
 var cnt:integer;
begin
//  writeln('AvaluE - ',Avalue);
 AValue+=#10;
 cnt:=0;
 while true do begin
  inc(cnt);
  fpseterrno(0);
  fppwrite(f,AValue[1],length(Avalue),0);
  e:=fpgeterrno;
  if (e=0)or(ev3Finalized) then break;
  if (cnt>=countMaxRefreshFactory)or(fowner=nil)then begin
    raise Ev3WriteException.create('TEv3Data Write Error: file - '+fn+' ; errorcode - '+inttostr(e)+' ; '+strerror(e));
  end;
  // произошел дисконнект, обновляем фабрику, пока устройство снова не подключится
  if beeperror then beepE(ord((fowner as tev3Device).Port),600 div cnt);//ev3Sound.beep(900-ord((fowner as tev3Device).Port)*100,600 div cnt);
  sleep(errorAttrInterval);
  ev3DeviceFactory.Refresh;
 end;
 //if not skipInterval then while millisecondsbetween(prevTime,now())<fWriteInterval do sleep(waitInterval);
 //prevTime:=now();
 // v0.2
// writeln('writeBeg ',fWriteInterval);
 if not skipInterval then timerWait(fWriteInterval);
// writeln('writeEnd ');
 timerStart();
end;

procedure TEv3Data.Reopen(filename: string);
 var m:cint;
begin
  fpseterrno(0);
//  writeln(fn,' + ',fmode,' - ',fpgeterrno );
  if f>0 then begin
  // writeln('>0!');
   fpclose(f);
  end;
  fpseterrno(0);
  case fmode of
   ev3ReadOnly: m:=O_RdOnly;
   ev3WriteOnly:m:=O_WrOnly;
   ev3ReadWrite:m:=O_RdWr;
  end;
//  writeln(fn,' - ',fmode,' - ',fpgeterrno );
  fn:=filename;
  f:=fpopen(fn,m);
  e:=fpgeterrno;
  if e<>0 then begin
    sleep(errorInitInterval);
    fpseterrno(0);
    f:=fpopen(fn,m);
    e:=fpgeterrno;
  end;
  if e<>0 then begin
    raise Ev3OpenException.create('TEv3Data Open Error: file - '+fn+' ; mode - '+inttostr(ord(fmode))+' ; errorcode - '+inttostr(e)+' ; '+strerror(e));
  end;
end;

procedure TEv3Data.setwiData(AValue: longint);
begin
 iData:=AValue;
end;

procedure TEv3Data.setwsData(AValue: string);
begin
 sData:=AValue;
end;

procedure TEv3Data.beepE(port: word; len:word);
 var tone,cnt:integer;
begin
  if port in [1..4] then begin
   tone:=400; cnt:=port;
  end
  else begin
   tone:=200; cnt:=port div 2;
  end;
  case cnt of
   1: ev3sound.beep(tone,len);
   2: ev3sound.beep([tone,len div 2,10,tone,len div 2,10]);
   3: ev3sound.beep([tone,len div 3,10,tone,len div 3,10,tone,len div 3,10]);
   4: ev3sound.beep([tone,len div 4,10,tone,len div 4,10,tone,len div 4,10,tone,len div 4,10]);
  end;
end;

function TEv3Data.endGetInterval: boolean;
// var dt:TDateTime;
begin
 if freadinterval=0 then exit(true);
// dt:=now();
// result:=MilliSecondsBetween(prevGetTime,dt)>fReadInterval;
// if result then prevGetTime:=dt;
// v0.2
 result:=timer(1)>fReadInterval;
 if result then timerStart(1);
end;

function TEv3Data.waitEvent(event: string; timeout: dword=high(dword)): boolean;
 var buf:string;
     //dt:tDateTime;
begin
 //dt:=now();
 // v0.2
 timerStart(2);
 event:=event;
 while true do begin
  buf:=sData;
  if buf=prevdata then begin
//    if MilliSecondsBetween(now(),dt)>=timeout then exit(false);
//    sleep(waitInterval);
// v0.2
    if timer(2)>=timeout then exit(false);
    sleep(waitInterval);
    continue;
  end;
  prevdata:=buf;
  exit(true);
 end;
end;

constructor TEv3Data.Create(filename: string; owner: TObject;
  _mode: TEv3DataMode);
begin
  inherited Create;
  fmode:=_mode; fowner:=owner;
  setIntervals(getInterval,setInterval);
  reopen(filename);
  if f<0 then begin
    writeln ('FAIL');
    fail;
  end;
end;

procedure TEv3Data.setIntervals(R, W: integer);
begin
 fWriteInterval:=W;
 fReadInterval:=R;
 if (w=0) and (r=0) then skipInterval:=true
 else skipInterval:=false;
end;

destructor TEv3Data.destroy;
begin
  fpclose(f);
  inherited destroy;
end;

procedure TEv3Data.hardPutData(data: shortstring);
 var ff:cint;
begin
 ff:=fpopen(fn,O_WrOnly);
 data+=#10;
 fpwrite(ff,data[1],length(data));
 fpclose(ff);
end;

end.

